"======================================================================
|
|   C object basic data type definitions.
| 
|   $Revision: 1.8 $
|   $Date: 1995/09/17 10:48:51 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	      7 May 95	  Added usage of more machine size constants
|			  (float,long, ptr, double).
|
| sbb	     29 Apr 95	  Moved the creation of CType instances into CType.
|			  Removed forward declaring of CType instances from
|			  this file and changed the load order to load CObject
|			  first since it now has no dependencies on the CType
|			  symbols. 
|
| sbb	      8 Jan 95	  Fixed some bugs with pointer subtraction.
|
| sbb	      8 Jan 95	  Converted to new types.
|
| sbb	     12 Jun 94	  added adjPtrBy:, derefAt:, etc. (finally).
|
| sbb	      9 Apr 94	  Added CScalar, value: methods on scalar instances as
|			  a shorthand notation for instance creation, started
|			  folding in the effects of the CType new method.
|
| sbb	     16 Feb 92	  created summer 90.
|
"

"Forward CType instances"

Smalltalk at: #CCharType put: nil!


!CObject methodsFor: 'inspection'!

inspect
    ^self value printNl
! !


!CObject class methodsFor: 'conversion'!

scalarIndex
    "Do nothing in the default case"
    ^self
! !



!CObject methodsFor: 'conversion'!

scalarIndex
    "Do nothing in the default case"
    ^self
!

castTo: aType
    ^self at: 0 type: aType
! !

!CObject methodsFor: 'accessing'!

value
    "What else can I return?"
    ^self hash
! !

CObject variableWordSubclass: #CScalar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'C variable access'
!


" ### Should keep scalar types from doing at: -- rehack to be basicAt:
 and remove at: from class CScalar"

CScalar variableWordSubclass: #CLong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'C variable access'!

!CScalar class methodsFor: 'instance creation'!

value: aValue
    | cObject |
    cObject _ self type new.
    cObject value: aValue.
    ^cObject
!

type				"Default type method"
    ^Smalltalk at: (self name, 'Type') asSymbol
! !



!CLong class methodsFor: 'accessing'!

sizeof
    ^CLongSize
!

alignof
    ^CLongSize
!

scalarIndex
    ^4
! !
    

!CLong methodsFor: 'accessing'!

value
    ^super at: 0 type: 4		"should be symbolic, but I want SPEED!"
!

value: aValue
    super at: 0 put: aValue type: 4
!

sizeof
    ^CLongSize
!

alignof
    ^CLongSize
! !


CScalar variableWordSubclass: #CULong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'C variable access'!

!CULong class methodsFor: 'accessing'!

sizeof
    ^CLongSize
!

alignof
    ^CLongSize
!

scalarIndex
    ^5
! !
    


!CULong methodsFor: 'accessing'!

value
    ^self at: 0 type: 5		"should be symbolic, but I want SPEED!"
!

value: aValue
    self at: 0 put: aValue type: 5
!

sizeof
    ^CLongSize
!

alignof
    ^CLongSize
! !


CScalar variableWordSubclass: #CShort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'C variable access'!

!CShort class methodsFor: 'accessing'!

sizeof
    ^2
!

alignof
    ^2
!

scalarIndex
    ^2
! !
    


!CShort methodsFor: 'accessing'!

value
    ^self at: 0 type: 2		"should be symbolic, but I want SPEED!"
!

value: aValue
    self at: 0 put: aValue type: 2
!

sizeof
    ^2
!

alignof
    ^2
! !


CScalar variableWordSubclass: #CUShort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'C variable access'!

!CUShort class methodsFor: 'accessing'!

sizeof
    ^2
!

alignof
    ^2
!

scalarIndex
    ^3
! !
    

!CUShort methodsFor: 'accessing'!

value
    ^self at: 0 type: 3		"should be symbolic, but I want SPEED!"
!

value: aValue
    self at: 0 put: aValue type: 3
!

sizeof
    ^2
!

alignof
    ^2
! !



CScalar variableWordSubclass: #CChar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'C variable access'!

!CChar class methodsFor: 'accessing'!

sizeof
    ^1
!

alignof
    ^1
!

scalarIndex
    ^0
! !
    

!CChar methodsFor: 'accessing'!

value
    ^self at: 0 type: 0		"should be symbolic, but I want SPEED!"
!

value: aValue
    self at: 0 put: aValue type: 0
!

sizeof
    ^1
!

alignof
    ^1
! !




CScalar variableWordSubclass: #CUChar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'C variable access'!

!CUChar class methodsFor: 'getting info'!

sizeof
    ^1
!

alignof
    ^1
!

scalarIndex
    ^1
! !

!CUChar methodsFor: 'accessing'!

value
    ^self at: 0 type: 1		"should be symbolic, but I want SPEED!"
!

value: aValue
    self at: 0 put: aValue type: 1
!

sizeof
    ^1
!

alignof
    ^1
! !



CScalar variableWordSubclass: #CFloat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'C variable access'!

!CFloat class methodsFor: 'accessing'!

sizeof
    ^CFloatSize
!

alignof
    ^CFloatSize
!

scalarIndex
    ^6
! !
    
!CFloat methodsFor: 'accessing'!

value
    ^self at: 0 type: 6		"should be symbolic, but I want SPEED!"
!

value: aValue
    self at: 0 put: aValue type: 6
!

sizeof
    ^CFloatSize
!

alignof
    ^CFloatSize
! !



CScalar variableWordSubclass: #CDouble
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'C variable access'!

!CDouble class methodsFor: 'accessing'!

sizeof
    ^CDoubleSize
!

alignof
    ^CDoubleAlignment
!

scalarIndex
    ^7
! !
    
!CDouble methodsFor: 'accessing'!

value
    ^self at: 0 type: 7		"should be symbolic, but I want SPEED!"
!

value: aValue
    self at: 0 put: aValue type: 7
!

sizeof
    ^CDoubleSize
!

alignof
    ^CDoubleAlignment
! !



CScalar variableWordSubclass: #CString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'C variable access'!

CString comment:
'Technically, CString is really a pointer to type char.  However, it''s
so darn useful as a distinct datatype, and it is a separate datatype
in Smalltalk, so we allow developers to express their semantics more precisely
by using a more descriptive type.

In general, I behave like a cross between an array of characters and a pointer
to a character.  I provide the protocol for both data types.  My #value
method returns a Smalltalk String, as you would expect for a scalar datatype.
'!

!CString class methodsFor: 'getting info'!

sizeof
    ^CPtrSize
!

alignof
    ^CPtrSize
!

scalarIndex
    ^8				"???not sure about this"
! !


!CString methodsFor: 'accessing'!

value
    ^self at: 0 type: 8		"should be symbolic, but I want SPEED!"
!

value: aValue
    self at: 0 put: aValue type: 8
!

sizeof
    ^CPtrSize
!

alignof
    ^CPtrSize
! !


!CString methodsFor: 'pointer like behavior'!

at: anIndex
    self derefAt: anIndex type: 0	"char"
!

addressAt: anIndex
    ^self at: anIndex type: CCharType	"verify this!!!"
!

at: anIndex put: aCharacter
    self derefAt: anIndex put: aCharacter type: 0
!

deref
    "Yields a CChar object."
    ^self derefAt: 0 type: CCharType
!

deref: aChar
    "Sets the pointed to char* to be that referred to by the CChar object"
    "Verify that this is the right semantics:  *foo = 'c' "
    self derefAt: 0 put: aChar type: 0 "char"
!

+ anInteger
    (anInteger isMemberOf: Integer)
	ifFalse: [ ^self error: 'Integer datatype required as right operand of +' ].
    "I'm not at all sure that this is the right semantic.  It's
     ptr + 3 yields new ptr.  This does *not* create a new variable to hold
     this pointer value; it just yields a new address value.  Our closest
     approximation is a pointer to char, which we represent as a CChar.  It 
     could return a new CString type as well"
    ^self derefAt: anInteger type: CCharType
!

- intOrPtr
    (intOrPtr isMemberOf: Integer)
	ifTrue: [ ^self 
		      derefAt: intOrPtr negated type: CCharType
		      "Might be better to create a new pointer instance?"
		      ].
    (intOrPtr isKindrOf: CString ) 
	ifTrue: [ ^self ptrDiff: intOrPtr elementSize: 1 derefFirst: true ].
									    
    self error: 'Integer or String required a second operand of "-"'.
!								   

incr
    self adjPtrBy: 1
!

decr
    self adjPtrBy: -1
!

incrBy: anInteger
    self adjPtrBy: anInteger
!

decrBy: anInteger
    self adjPtrBy: anInteger negated
!

"Could also be a byteArray that we replace with"
replaceWith: aString
    <primitive: 188>
    ^self primitiveFailed
! !


!CString methodsFor: 'private'! 

ptrDiff: subtractedPtr elementSize: anInteger derefFirst: aBoolean
    <primitive: 186>
    ^self primitiveFailed
!

adjPtrBy: byteOffset
    <primitive: 187>
    ^self primitiveFailed
!

derefAt: byteOffset type: aType
    <primitive: 182>
    ^self primitiveFailed
!

derefAt: byteOffset put: aValue type: aType
    <primitive: 184>
    ^self primitiveFailed
! !

"???Should Arrays, Ptrs, etc be subclasses of CAggregate?"

"Common protocol to both arrays and pointers

deref
!

at: anIndex
!

+ anInteger

- anInteger

- aPointeroid
"



CObject variableWordSubclass: #CArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'C variable access'!

!CArray methodsFor: 'accessing'!

at: anIndex
    | elementType |
    "Returns a new CObject of the element type."
    elementType _ self type elementType.
    ^self at: (anIndex * elementType sizeof) 
	  type: elementType valueType
!

addressAt: anIndex
    | elementType |
    elementType _ self type elementType.
    ^self at: (anIndex * elementType sizeof) type: elementType
!					       

at: anIndex put: aValue
    | elementType  |
    elementType _ self type elementType .
    ^self at: (anIndex * elementType sizeof) 
	  put: aValue
	  type: elementType valueType 
!    

sizeof
    | type |
    type _ self type.
    ^type numElements * type elementType sizeof
!

alignof
    ^self type elementType alignof
!

inspect
    | type |
    type _ self type.
    stdout nextPutAll: '['; nl.
    1 to: type numberOfElements do: 
	[ :i | stdout nextPutAll: '    '.
	       (self at: i) inspect ].
    stdout nextPutAll: ']'; nl
! !



!CArray methodsFor: 'pointer like behavior'!

deref	
    ^self at: 0
!
					       
+ anInteger
    | elementType |
    (anInteger isMemberOf: Integer)
	ifFalse: [ ^self error: 'CArray>>+ requires an integer second operand' ].
    elementType _ self type elementType.
    ^self at: (anInteger * elementType sizeof) type: elementType
!

- intOrPtr
    | elementType |
    (intOrPtr isMemberOf: Integer)
	ifTrue: [ elementType _ self type elementType.
		  ^self at: (intOrPtr * elementType sizeof) negated
			type: elementType ].
    (intOrPtr isKindOf: CArray ) "!!! test for subtype equiv too!"
	ifTrue: [ ^self ptrDiff: intOrPtr deref: false ].
									    
    self error: 'Integer or CArray required a second operand of "-"'.
! !


CObject variableWordSubclass: #CPtr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'C variable access'!


!CPtr class methodsFor: 'accessing'!

sizeof
    ^CPtrSize
!

alignof
    ^CPtrSize
! !



!CPtr methodsFor: 'accessing'!

deref
    ^self value
!

at: anIndex
    | elementType type |
    type _ self type.
    elementType _ type elementType.
    "elementType inspect.
    elementType valueType printNl. "
    
    ^self derefAt: (anIndex * elementType sizeof) 
	  type: elementType valueType
!

addressAt: anIndex
    | elementType |
    elementType _ self type elementType.
    ^self at: (anIndex * elementType sizeof) type: elementType
!

at: anIndex put: aValue
    | elementType |
    elementType _ self type elementType.
    self derefAt: (anIndex * elementType sizeof) put: aValue
	 type: elementType valueType
!

value
    ^self at: 0
!

value: aValue
    ^self at: 0 put: aValue type: nil
	"Type doesn't matter"
!

incr
    self adjPtrBy: self type elementType sizeof
!

decr
    self adjPtrBy: self type elementType sizeof negated
!

incrBy: anInteger
    self adjPtrBy: self type elementType sizeof * anInteger
!

decrBy: anInteger
    self incrBy: anInteger negated
!

+ anInteger
    | type |
    (anInteger isMemberOf: Integer)
	ifFalse: [ ^self error: 'Integer datatype required as right operand of +' ].
    "I'm not at all sure that this is the right semantic.  it's
     ptr + 3 yields new ptr.  This does *not* create a new variable to hold
     this pointer value; it just yields a new address value.  Our closes 
     approximation is a pointer to char, which we represent as a CChar."
    type _ self type.
    ^self derefAt: anInteger type: type elementType
!

- intOrPtr
    | elementType |
    elementType _ self type elementType.
    (intOrPtr isMemberOf: Integer)
	ifTrue: [ ^self 
		      derefAt: (intOrPtr * elementType sizeof) negated
		      type: elementType
		      "Might be better to create a new pointer instance?"
		      ].
    (intOrPtr isKindOf: CPtr ) 
	ifTrue: [ ^self ptrDiff: intOrPtr 
			elementSize: elementType sizeof  
			derefFirst: true ].
									    
    self error: 'Integer or String required a second operand of "-"'.
!								   


sizeof
    ^CPtrSize
!

alignof
    ^CPtrSize
!

inspect
    stdout nextPutAll: '--> '.
    self value inspect
! !


!CPtr methodsFor: 'private'!

adjPtrBy: byteOffset
    <primitive: 187>
    ^self primitiveFailed
!

derefAt: byteOffset type: aType
    <primitive: 182>
    ^self primitiveFailed
!

derefAt: byteOffset put: aValue type: aType
    <primitive: 184>
    ^self primitiveFailed
! !


CUChar variableWordSubclass: #CByte
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: 'C variable access'
!

CByte comment: 'You''re a marine.
You adapt -- you improvise -- you overcome

    	    	    	- Gunnery Sgt. Thomas Highway
    	    	    	  Heartbreak Ridge'!

!CByte methodsFor: 'accessing'!

value
    ^super value asciiValue
!

value: anInteger
    ^super value: (Character value: anInteger)
! !


