"======================================================================
|
|   C preprocessor adjacent string concatenator layer
|
|   $Revision: 1.4 $
|   $Date: 1995/06/06 14:54:50 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
|
"

FileStream fileIn: 'CToken.st' ifMissing: #CToken !
FileStream fileIn: 'PushBackStream.st' ifMissing: #PushBackStream !

PushBackStream subclass: #StringConcatStream
	       instanceVariableNames: ''
	       classVariableNames: ''
	       poolDictionaries: ''
	       category: nil
!

StringConcatStream comment:
'I process a sequence of tokens, looking for adjacent strings to put together
into one long string token.'
!


!StringConcatStream methodsFor: 'accessing'!

peek
    | result nextTok |
    queue size > 0
	ifTrue: [ ^super peek ].
    result _ self next.
    self putBack: result.
    ^result.
!

next
    | result nextTok |
    result _ super next.
    (result isKindOf: StringTok)
	ifTrue: 
	    [ [ stream atEnd not and: 
		    [ (nextTok _ super peek) isKindOf: StringTok ] ]
		  whileTrue: [ super next. "gobble the string"
			       result _ StringTok value: (result value, 
							      nextTok value) ].
	      ].
    ^result
! !
