"======================================================================
|
|   Smalltalk in Smalltalk compiler symbol table helper object
|
|   $Revision: 1.1 $
|   $Date: 1995/09/17 07:18:33 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"


"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	      3 Sep 95	  created.
|
"

Compiler subclass: #STVariableDefinition
       instanceVariableNames: 'name definition'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

STVariableDefinition comment:
'I am an abstract base class for Smalltalk compiler variable definitions.
My instances can answer the variable name, and can act as predicates talking 
about the scope that the variable was defined in (if it was defined).'!



!STVariableDefinition class methodsFor: 'instance creation'!

name: name definition: aDefinition
    ^self new init: varName definition: aDefinition
! !


!STVariableDefinition methodsFor: 'predicates'!

"All these base class definitions return false, so that the subclasses
only have to return true for what they are"

isTemporary
    ^false
!

isInstVar
    ^false
!

isGlobal
    ^false
!

isUnknown
    ^false
! !


!STVariableDefinition methodsFor: 'accessing'!

name
    ^name
!

definition
    ^definition
! !



!STVariableDefinition methodsFor: 'private'!

name: aName definition: aDefinition
    name _ aName.
    definition _ aDefinition.
! !




STVariableDefinition subclass: #STTempVariable
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 


!STTempVariable methodsFor: 'predicates'!

isTemporary
    ^true
! !


STVariableDefinition subclass: #STInstVariable
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 


!STInstVariable methodsFor: 'predicates'!

isInstVar
    ^true
! !


STVariableDefinition subclass: #STGlobalVariable
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

!STGlobalVariable methodsFor: 'predicates'!

isGlobal
    ^true
! !

STVariableDefinition subclass: #STUnknownVariable
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 


!STUnknownVariable methodsFor: 'predicates'!

isUnknown
    ^true
! !
