"======================================================================
|
|   Smalltalk lexical token definitions.
|
|   $Revision: 1.4 $
|   $Date: 1995/06/06 14:54:50 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"


"
|     Change Log
| ============================================================================
| Author       Date       Change 
|
"

Object subclass: #Token
       instanceVariableNames: 'location'
       classVariableNames: ''
       poolDictionaries:''
       category: 'Compiler'
!

Token comment:
'My instances are returned from the lexer stream.  If you ask them (nicely,
mind you) they will report their kind (a symbol, such as #Identifier) and
their value (such as ''foobar'').' !

Token subclass: #ValueToken
      instanceVariableNames: 'value'
      classVariableNames: ''
      poolDictionaries: ''
      category: 'Compiler'
!



!ValueToken class methodsFor: 'instance creation'!

value: aValue
    ^self new init: aValue
! !

!ValueToken methodsFor: 'accessing'!

value
    ^value
! !

!ValueToken methodsFor: 'private'!

init: aValue
    value _ aValue
! !

    
Token subclass: #VerticalBarTok
      instanceVariableNames: ''
      classVariableNames: ''
      poolDictionaries: ''
      category: 'Compiler' 
!

!VerticalBarTok methodsFor: 'accessing'!

value
    ^'|'
! !

Token subclass: #BangTok
      instanceVariableNames: ''
      classVariableNames: ''
      poolDictionaries: ''
      category: 'Compiler' 
!

!BangTok methodsFor: 'accessing'!

value
    ^'!'
! !


#(  DotTok
    SharpTok
    ColonTok
    OpenParenTok
    CloseParenTok
    SemiTok
    OpenBracketTok
    CloseBracketTok
    UpArrowTok
    AssignTok 
    PrimitiveStartTok
) do: [ :className | Token subclass: className
			   instanceVariableNames: ''
			   classVariableNames: ''
			   poolDictionaries: ''
			   category: 'Compiler' ]
!

#(  SymbolTok
    LiteralTok			"string, integer, float, character"
    CommentTok
    IdentifierTok
    KeywordTok
    SymbolKeywordTok
    BinopTok
) do: [ :className | ValueToken subclass: className
			   instanceVariableNames: ''
			   classVariableNames: ''
			   poolDictionaries: ''
			   category: 'Compiler' ]
!

