/* acconfig.h
   Copyright (C) 1994, 1995 Free Software Foundation, Inc.
   Written by Steve Byrne.

   $Revision$ $Date$

   Descriptive text for the C preprocessor macros that
   the distributed Autoconf macros can define.
   No software package will use all of them; autoheader copies the ones
   your configure.in uses into your configuration header file templates.

   The entries are in sort -df order: alphabetical, case insensitive,
   ignoring punctuation (such as underscores).  Although this order
   can split up related entries, it makes it easier to check whether
   a given entry is in the file.

   Leave the following blank line there!!  Autoheader needs it.  */


/* Define this if your system makes a distinction between opening a file in 
 * raw mode (binary mode), or whether you have winning system that terminates
 * file lines with newline/lf/0x0A the way it was meant to be
 */
#undef BINARY_MODE_NEEDED

/* This is enabled if you want the ultra-winning GNU dynamic loader package
 * loaded into GNU Smalltalk.  At some point, GNU Smalltalk may automatically
 * use this if the local system has it installed */
#undef USE_DLD

/* This is anbled if you wnat the also ultra-winning GNU readline library
 * to be present in the command reader.
 */
#undef USE_READLINE

/* Define this with the memory alignment required by type "double" */
#define DOUBLE_ALIGNMENT 0

/* Define if your system's definition of `struct termios' has a member
   named c_line.  */
#undef HAVE_C_LINE

/* Define if your system has SysV shadow passwords and the shadow.h header.  */
#undef HAVE_SHADOW_H

/* Define if your system has io.h to define io functions */
#undef HAVE_IO_H

/* Define if your system uses stdarg.h for varargs support */
#undef HAVE_STDARG_H

/* Define if your system lacks gethostname but has the uname system call.  */
#undef HAVE_UNAME

/* Define if your system's struct utmp has a member named ut_host.  */
#undef HAVE_UT_HOST

/* Define if you have unistd.h and it defines ioctl (like IRIX 5.3's does) */
#undef IOCTL_IN_UNISTD_H

/* The set of builtin preprocessor symbols which are defined in the current 
 * environment.
 */
#define MACHINE_DEFINES "unknown", 

/* Define if your system lacks the getpriority and setpriority system calls,
   but has `nice' instead.  */
#undef NICE_PRIORITY

/* Internal profiling */
#undef PROFBLOCK

/* Enabling this makes the the allocator run the GC with each allocation to
 * test for non-incubated objects being freed too soon.
 */
#undef GC_TORTURE

/* Major version of GNU Smalltalk */
#define ST_MAJOR_VERSION 0

/* Minor version of GNU Smalltalk */
#define ST_MINOR_VERSION 0

/* Patch level version of GNU Smalltalk */
#define ST_EDIT_VERSION 0

/* Prefix (like "alpha" or "test" before the edit number) */
#define ST_EDIT_PREFIX ""

/* The current version of GNU Smalltalk */
#define VERSION 0.0

/* **********************************************************************
 * **********************************************************************
 * 
 * These definitions hack around a bug with the GNU autoconf package.
 * autoheader will complain that these symbols are not defined in acconfig.h
 * if they are not present here.  But, other higher level AC_ macros in
 * configure.in will cause them to be emitted anyway, so now they go out
 * twice in config.h.  
 * 
 * **********************************************************************
 * ********************************************************************** */

#undef HAVE_SYS_TIME_H

#undef HAVE_GETTIMEOFDAY


/* Leave that blank line there!!  Autoheader needs it.
   If you're adding to this file, keep in mind:
   The entries are in sort -df order: alphabetical, case insensitive,
   ignoring punctuation (such as underscores).  */

