"File PRadioBtn.st
======================================================================
|
| Copyright (C) 1995 Free Software Foundation, Inc.
| Written by Brad Diller.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================
 

|     Change Log
| ============================================================================
| Author        Date              Change
| bdiller       11 Oct 93         Created.
| bdiller       12 Jul 95         Modified extensively to support
|                                 revamped window management system.
"


Primitive subclass:  #PRadioButton
        instanceVariableNames: 'state isPressedMsg'
        classVariableNames: ''
        poolDictionaries: ''
        category: 'Graphics Windows'
!

!BRadioButton methodsFor: 'private'!!

Behavior defineCFunc: 'getToggleValue'
         withSelectorArgs: 'getValue: guiObject'
         forClass: BRadioButton
         returning: #int
         args: #(cObject)
!

Behavior defineCFunc: 'setToggleValue'
         withSelectorArgs: 'set: guiObject value: aBoolean'
         forClass: BRadioButton
         returning: #void
         args: #(cObject int)
!

!BRadioButton methodsFor: 'accessing'!

value
    ^(self getValue: guiObject) ~= 0
!

value: aBoolean
    self set: guiObject value: aBoolean
! !

!PRadioButton class methodsFor: 'instance creation'!

on: data parentView: sv isPressed: isPressedSelector label: label 
    handleUserChange: changeSelector value: onValue
    | view |        
    view := self new.
    view parentView: sv.
    view data: data.
    view isPressed: isPressedSelector; state: onValue.
    view handleUserChange: changeSelector.
    view initBlox: label.
    ^view.
!!

!PRadioButton methodsFor: 'initialize-delete'!

initBlox: aLabel
    blox := BRadioButton new: parentView label: aLabel.
    blox value: (self isPressed).
    blox callback: self message: 'toggle:'.
!

isPressed: isPressedSelector
    isPressedMsg := isPressedSelector.
!!

!PRadioButton methodsFor: 'access'!

state
    ^state
!

state: value
    state := value
!

isPressed
"Return current switch state."
    ^(data perform: isPressedMsg) = state.
!!

!PRadioButton methodsFor: 'message selectors'!

toggle: state
"Send the modification message to the data object"
    (stateChangeMsg notNil and: [self canChangeState])
	ifTrue: [data perform: stateChangeMsg with: (self isPressed not)].
!!
