"File StkInspect.st
======================================================================
|
| Copyright (C) 1995 Free Software Foundation, Inc.
| Written by Brad Diller.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================
 

|     Change Log
| ============================================================================
| Author     	Date         	Change
| bdiller      	7 July 95.  Derived from sbb's BBrowser.st
|
"
Inspector subclass:  #StackInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graphics Windows'
!

!StackInspector methodsFor: 'private'!

getMethodFromContext: context
    "limit for right now to just method contexts"
    ^context method.
!

currentVariableValue
"Return value at currently selected key"
    currentVariable == 0
	ifTrue: [ ^nil].
    currentVariable == 1
	ifTrue: [ ^theObject ].
    ^(theObject at: currentVariable - 1).
!

currentVariable: obj
    theObject at: currentVariable - 1 put: obj
!

setInstanceVars: anObject
    | method totalVars stackVars |
    theObject _ anObject.
    method _ self getMethodFromContext: anObject.
    totalVars _ method numArgs + method numTemps.

    instVars _ OrderedCollection new: totalVars + 1.
    instVars add: #thisContext.
    
    1 to: totalVars do:
	[ :i | instVars add: i printString ].
!!

