"File backtrace.st "
"======================================================================
|
| Copyright (C) 1990, 1991, 1992 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"


"
|     Change Log
| ============================================================================
| Author		Date		Change 
| bdiller		18 Oct 93 	Derived from t.st.
"

! MethodContext methodsFor: 'accessing' !

parentContext
    ^sender
!
backtraceString
    | aString |
    aString := '#', receiver class printString.
    methodClass == receiver class
        ifFalse: [ aString := aString, '(', methodClass printString, ')' ].
    aString := aString, '>>'.
    (selector isKindOf: Symbol)
        ifTrue: [ aString := aString, '#' ].
    aString := aString, selector printString.
    ^aString
!
sender
    ^sender
!
ip
    ^ip
!
sp
    ^sp
!
method
    ^method
!
methodClass
    ^methodClass
!
block
    ^block
!
selector
    ^selector
!
receiver
    ^receiver
!!

! BlockContext methodsFor: 'accessing' !

parentContext
    ^caller
!
backtraceString
    ^'#[] in ', home methodClass printString,
                     '>>#', home selector printString
!
caller
    ^caller
!
ip
    ^ip
!
sp
    ^sp
!
numArgs
    ^numArgs
!
methodClass
    ^methodClass
!
initialIP
    ^initialIP
!
selector
    ^selector
!
home
    ^home
!!

! SystemDictionary methodsFor: 'backtrace' !

newBacktrace
    | n context aCollection |
    aCollection := OrderedCollection new.
    n := 0.
    context := thisContext.
    [ context notNil ]
        whileTrue: [ n := n + 1. context := context parentContext ].
    context := thisContext.
    n to: 1 by: -1 do:
        [ :i | aCollection add: context backtraceString.
	       context := context parentContext ].
    ^aCollection
!!
