"File t2.st
======================================================================
|
| Copyright (C) 1995 Free Software Foundation, Inc.
| Written by Brad Diller.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================
 

|     Change Log
| ============================================================================
| Author     Date         Change
| sbb	     29 Aug 95	  Converted to use new Smalltalk variable for location
|			  of kernel files.
|
| bdiller       18 Sept 93      Created.
|
"
"Smalltalk blox initialization script"

stdout nextPutAll: KernelFilePath, '/blox/ Initializing system -- be patient...'; nl!

FileStream verbose: true.

"Place holders for some global objects"
(Smalltalk includesKey: #Primitive)
    ifFalse: [ Smalltalk at: #Primitive put: nil ]!
(Smalltalk includesKey: #Inspector)
    ifFalse: [ Smalltalk at: #Inspector put: nil ]!
(Smalltalk includesKey: #DictionaryInspector)
    ifFalse: [ Smalltalk at: #DictionaryInspector put: nil ]!
(Smalltalk includesKey: #BrowserMain)
    ifFalse: [ Smalltalk at: #BrowserMain put: nil ]

"When the Smalltalk image is saved, the initialization status recorded in the
class variable, 'shell', is also saved.  Consequently, we need to 
re-initialize this class variable to inform the system that Motif has not been 
initialized" 

    ifTrue: [ (Smalltalk at: #BrowserMain) close ]!
(Smalltalk includesKey: #ClassHierarchyBrowser)
    ifFalse: [ Smalltalk at: #ClassHierarchyBrowser put: nil ]!
(Smalltalk includesKey: #Prompter)
    ifFalse: [ Smalltalk at: #Prompter put: nil ]!
(Smalltalk includesKey: #ModalDialog)
    ifFalse: [ Smalltalk at: #ModalDialog put: nil ]!
(Smalltalk includesKey: #MethodSetBrowser)
    ifFalse: [ Smalltalk at: #MethodSetBrowser put: nil ]!

#(
"Existing 1.2 graphics units not incorporated into the graphics kernel"
  'Point.st'
  'Rectangle.st'

"Additions to standard classes"
  'blox/Extras.st'
  'blox/GuiData.st'

  'blox/backtrace.st'
"Now the graphics kernel"
  'blox/View.st'
  'blox/Manager.st'
  'blox/Form.st'
  'blox/RadioForm.st'
  'blox/TopLevel.st'
  'blox/Primitive.st'
  'blox/PList.st'
  'blox/PText.st'
  'blox/PRadioBtn.st'
  'blox/Menu.st'
  'blox/ModalDialog.st'
  'blox/Prompter.st'

"View classes"
  'blox/BrowserMain.st'
  'blox/ClassBrow.st'
  'blox/Inspector.st'
  'blox/DictInspect.st'
  'blox/MethSetBrow.st'

"Load files that support Steve's walkback inspector"
  'blox/StkInspect.st'
  'blox/CtxtInspect.st'
  'blox/ErrInspect.st'
) do: [ :file | FileStream fileIn: KernelFilePath , '/', file ]!
	       

Smalltalk snapshot!

