Object subclass: #File
       instanceVariableNames: 'name'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

"Linux defs:
   size_t  uint
   time_t  long
   clock_t long
   uid_t   ushort
   gid_t   ushort
   dev_t   ushort
   ino_t   ulong
   umode_t ushort
   off_t   long
   nlink_t ushort
"   

CStruct newStruct: #StatStruct
	 declaration:
	     #( 
	       (stDev uShort)		" device "
	       (stIno uLong)		" inode "
	       (stMode uShort)          " protection "
               (stNlink uShort)         " number of hard links "
	       (stUid uShort)           " user ID of owner "
               (stGid uShort)           " group ID of owner "
               (stRdev uShort)		" device type (if inode device) "
               (stSize long)            " total size, in bytes "
               (stBlksize uLong)        " blocksize for filesystem I/O "
               (stBlocks uLong)		" number of blocks allocated "
               (stAtime long)		" time of last access "
               (stMtime long)		" time of last modification "
               (stCtime long)		" time of last change "
		   )
!

"
              struct stat
              {
                  dev_t         st_dev;      /* device */
                  ino_t         st_ino;      /* inode */
                  umode_t       st_mode;     /* protection */
                  nlink_t       st_nlink;    /* number of hard links */
                  uid_t         st_uid;      /* user ID of owner */
                  gid_t         st_gid;      /* group ID of owner */
                  dev_t         st_rdev;     /* device type (if inode device) */
                  off_t         st_size;     /* total size, in bytes */
                  unsigned long st_blksize;  /* blocksize for filesystem I/O */
                  unsigned long st_blocks;   /* number of blocks allocated */
                  time_t        st_atime;    /* time of last access */
                  time_t        st_mtime;    /* time of last modification */
                  time_t        st_ctime;    /* time of last change */
              };


"

Behavior defineCFunc: 'stat'
	 withSelectorArgs: 'statOn: fileName into: statStruct'
	 forClass: File
	 returning: #int
	 args: #(string cObject)
!

Behavior defineCFunc: 'lstat'
	 withSelectorArgs: 'linkStatOn: fileName into: statStruct'
	 forClass: File
	 returning: #int
	 args: #(string cObject)
!

!File class methodsFor: 'instance creation'!

name: aName
    ^self new init: aName
! !

!File methodsFor: 'accessing'!

name
    ^name
!

stat
    | struct |
    struct _ StatStruct new.
    self statOn: name into: struct.
    ^struct
! !



!File methodsFor: 'private'!

init: aName
    name _ aName
! !
    
!File class methodsFor: 'testing'!

test
    | file |
    file _ File name: 'File.st'.
    file stat inspect
! !
    

"
File test!

"    

