FileStream fileIn: '../DLD.st'!

"
Hosts addressAt: aHostName returns instance of IPAddress which
prints as 130.44.22.10 and which has operators to write one to a place
in memory or to a file as bytes, and to read from memory or a file
Uses gethostbyname

Hosts hostNameAt: ipAddress
uses get host by addr
needs address length, and type (from netdb.h)

              struct    hostent {
                   char *h_name;  /* official name of host */
                   char **h_aliases;   /* alias list */
                   int  h_addrtype;    /* host address type */
                   int  h_length; /* length of address */
                   char **h_addr_list; /* list of addresses from name server */
              };
              #define   h_addr  h_addr_list[0]   /* address, for backward compatibility */

       The members of this structure are:

       h_name       Official name of the host.

       h_aliases    A  zero  terminated  array of alternate names
                    for the host.

       h_addrtype   The type of address being returned; currently
                    always AF_INET.

                          June 23, 1990                         1

       h_length     The length, in bytes, of the address.

       h_addr_list  A  zero terminated array of network addresses
                    for the host.  Host addresses are returned in
                    network byte order.

       h_addr       The first address in h_addr_list; this is for
                    backward compatiblity.

Hosts namesDo: 
Hosts addressesDo:
(uses gethostent, and possibly sethostent and endhostent)
"

ByteArray variableByteSubclass: #IPAddress
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

!IPAddress class methodsFor: 'instance creation'!

new
    ^self basicNew: 4
!

fromPtr: aCObject
    ^self new initFromPtr: aCObject
!

fromString: aString
    ^self notYetImplemented "parses 130.4.49.2"
! !

!IPAddress methodsFor: 'printing'!

printOn: aStream
    | isFirst |
    isFirst _ true.
    self do:
	[ :byte | isFirst 
		      ifTrue: [ isFirst _ false ]
		      ifFalse: [ aStream nextPut: $. ].
		  aStream print: byte. ].
! !


!IPAddress methodsFor: 'private'!

fromPtr: aCObject
    "??? can use replace contents here?"
    1 to: self size do:
	[ :i | self at: i
		    put: (aCObject at: aCObject + i - 1 
				   type: CUChar scalarIndex) ].
! !







CStruct newStruct: #HostEntry
	declaration:
	    #(
	      (name string)
	      (aliases (ptr string))
	      (addrType long)
	      (length long)
	      (addrList (ptr (ptr uChar)))
		  )
!

Object subclass: #Hosts
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

DLD defineExternFunc: 'gethostbyname'
    withSelectorArgs: 'byName: name'
    forClass: Hosts class
    returning: (CType baseType: HostEntry)
    args: #(string)
!

!Hosts class methodsFor: 'accessing'!

addressAt: aHostName
    | hostEntry ipAddr ptr |
    hostEntry _ self byName: aHostName.
    (hostEntry addrList at: 0 ) printNl.
    "
    hostEntry deref printNl.
    
    ptr _ hostEntry addrList.
    ptr inspect.
    ptr value inspect.
    [ ptr deref ~= nil ] whileTrue:
	[ ipAddr _ IPAddress fromPtr:  ptr deref value.
	  ipAddr printNl.
	  ptr incr. ]."
	 
! !






| x |
    Hosts addressAt: 'taligent.com'.
     "(Hosts byName: 'taligent.com') inspect."

!
