'Filed out from Smalltalk version 1.2.alpha3 on 27-Jul-95  7:41:10 GMT'!

STObject subclass: #MethodBrowserController
    instanceVariableNames: 'scrolledText browser splitView window winDelegate browseTypeMatrix methodBrowserDelegate buttonMatrix class box '
    classVariableNames: 'isa '
    poolDictionaries: ''
    category: nil
!

MethodBrowserController comment: 'Created whenever a class is double clicked on'!

!MethodBrowserController methodsFor: 'Accessing'!

window
	^window

!!

!MethodBrowserController methodsFor: 'Action'!

action3: sender
	| matrix tag |
	sender _ Matrix newWithId: sender.
	tag _ sender selectedCol.
	
	tag == 0
		ifTrue: [ ^self ].
	tag == 1
		ifTrue: [ ^self ].
	tag == 2
		ifTrue: [ ^self fileOutCategory. ]. 
	tag == 3
		ifTrue: [ ^self addMethod. ]. 
	tag == 4
		ifTrue: [ ^self compileMethod. ]. 
	tag == 5
		ifTrue: [ ^self removeMethod. ]. 
!

action2: sender
	| matrix tag |
	sender _ Matrix newWithId: sender.
	tag _ sender selectedCol.
	
	tag == 1
		ifTrue: [ methodBrowserDelegate browseInstanceMethods. ].
	tag == 2
		ifTrue: [ methodBrowserDelegate browseClassMethods. ].
	
	browser loadColumnZero.
!

action1: sender
	| cell selectedSel methodString text |

	text _ scrolledText text.
	cell _ browser selectedCell.
	selectedSel _ cell stringValue asSymbol.
	
	(class canUnderstand: selectedSel)
		ifTrue:  [
			methodString _ class sourceCodeAt: selectedSel.
			text setText: methodString.
			text sizeToFit.
			text scrollSelToVisible.
			scrolledText display.
			^self ].
			
	((class class) canUnderstand: selectedSel)
		ifTrue:  [
			methodString _ (class class) sourceCodeAt: selectedSel.
			text setText: methodString.
			text sizeToFit.
			text scrollSelToVisible.
			scrolledText display ].
!!

!MethodBrowserController methodsFor: 'Creating New Code'!

addMethod
	| text template |
	text _ scrolledText text.
	text setText: 'newMethod: anArg
	" A comment "
	^self'.
	scrolledText display.		
!

compileMethod
	| code len codeStream result text cell category |
	text _ scrolledText text.
	len _ text textLength.
	code _ String new: (len + 1).  	
	text getSubstring: code start: 0 length: len.
	
	cell _ ((browser matrixInColumn: 0) selectedCell).
	cell notNil
		ifTrue: [ class compile: code classified: (cell stringValue) ]
		ifFalse: [ class compile: code classified: 'New Category' ]
!

removeMethod
	| cell selectedSel methodString text |
	cell _ ((browser matrixInColumn: 1) selectedCell).

	" Need to popup a warning panel asking the user if they really
	  want to delete this method "

	cell notNil
		ifTrue: [ class removeSelector: ((cell stringValue) asSymbol) ]
!

addCategory
!

fileOutCategory
	| cell matrix category savePanel value file filename dir rect |

	matrix := browser matrixInColumn: 0.
	cell :=  matrix selectedCell.
	category :=  cell stringValue.

	cell notNil
		ifTrue: [
			rect _ Rect alloc initFromX: 200.0 y: 200.0 width: 500.0 height: 400.0.
			savePanel _ SavePanel newContent: (rect asCPointer) 
							style: 6 
							backing: 2 
							buttonMask: (4 bitOr: 1) 
							defer: YES.
			savePanel setRequiredFileType: 'st'.
			savePanel setTitle: 'Filing Out Catagories'.
			filename _ class name, '.', category, '.st'.
			value _ savePanel runModalForDirectory: './' file: filename. 
			
			value == 1
				ifTrue: [
					filename _ savePanel filename.
					dir _ savePanel directory.
					
					" need to check if the file exists, if it does we
					  need to rename it filename~ and then file out
					  the selected catagory "
					  
					file _ FileStream open: filename mode: 'w'.
					file notNil
						ifTrue: [ class fileOutCategory: category on: file. file close ] 
						ifFalse: [ self error: 'Couldn''t open file', filename ]. ]. ].
	
!!

!MethodBrowserController methodsFor: 'Freeing'!

free
	" Since I don't know the mechanism by which smalltalk free
	  objects I will free stuff explicitly whenever certain
	  windows are closed. "

	'Freeing a MethodBrowserController' printNl.

	scrolledText free.
	browser free.
	browseTypeMatrix free.
	buttonMatrix free.
	methodBrowserDelegate free.
	splitView free.
	box free.

	super free.
!!

!MethodBrowserController methodsFor: 'Intialization'!

initScrolledText: rect
	| font tan |
	scrolledText _ TextScrollView alloc initFrame: rect.
	font _ Font newFont: 'Ohlfs' size: 10.0.
	(scrolledText text) setMonoFont: YES.
	(scrolledText text) setFont: (font id).

	tan _ Color alloc init.
	tan setRedComponent: (255.0 / 255.0).
	tan setGreenComponent: (204.0 / 255.0).
	tan setBlueComponent: (119.0 / 255.0).
	scrolledText setBackgroundColor: tan.!

initBrowseTypeButtonMatrix: aRect
	| bounds size font |
	
	bounds _ Rect alloc initFromRect: (aRect asCPointer).
	size _ Size alloc init.
	bounds setX: 6.0 ; setY: ((aRect height) - 30.0) ; setHeight: 24.0 ; setWidth: ((aRect width) - 12.0).
	
	browseTypeMatrix _ Matrix alloc initFrame: (bounds asCPointer)
							mode: 2							"NX_LISTMODE"
							cellClass: (ButtonCell isa)
							numRows: 1
							numCols: 3.
	browseTypeMatrix setAutosizing: (2 bitOr: 8).
	browseTypeMatrix setAutosizeCells: YES.
	browseTypeMatrix setIntercell: (size asCPointer).
	
	font _ Font newFont: 'Helvetica-Bold' size: 10.0.
	browseTypeMatrix setFont: font id.
	
	browseTypeMatrix setAction: (OCInterface getUid: 'action2:').
	browseTypeMatrix setTarget: (self id).
		
	browseTypeMatrix setTitle: 'Browse Methods:' at: 0 anArg: 0.
	browseTypeMatrix setTitle: 'Instance' at: 0 anArg: 1.
	browseTypeMatrix setTitle: 'Class' at: 0 anArg: 2.
	"browseTypeMatrix setTitle: 'Both' at: 0 anArg: 3."
	
	(browseTypeMatrix cellAt: 0 anArg: 0) setEnabled: NO.
	(browseTypeMatrix cellAt: 0 anArg: 0) setBordered: NO.
	(browseTypeMatrix selectCellAt: 0 anArg: 1).
!

initWindow: rect
	window _ Window alloc initContent: (rect asCPointer)
								style: 6
							  backing: 2
						   buttonMask: (4 bitOr: 1)
								defer: YES.
	window setTitle: 'Method Browser for ', class name.

    winDelegate _ FreeOwnerWindowDelegate alloc init.
	winDelegate owner: self.
	window setDelegate: winDelegate id.
!

initButtonMatrix: aRect
	| bounds size font |
	
	bounds _ Rect alloc initFromRect: (aRect asCPointer).
	size _ Size alloc init.
	bounds setX: 0.0 ; setY: 0.0 ; setHeight: 60.0; setWidth: 180.0. "((bounds width) - 10.0)."
	
	buttonMatrix _ Matrix alloc initFrame: (bounds asCPointer)
							mode: 0							"NX_LISTMODE"
							cellClass: (ButtonCell isa)
							numRows: 1
							numCols: 6.
	buttonMatrix setAutosizeCells: YES.
	buttonMatrix setIntercell: (size asCPointer).
	
	font _ Font newFont: 'Helvetica-BoldOblique' size: 10.0.
	buttonMatrix setFont: font id.

	buttonMatrix setAction: (OCInterface getUid: 'action3:').
	buttonMatrix setTarget: (self id).

	buttonMatrix setTitle: 'Add...' at: 0 anArg: 0.
	buttonMatrix setTitle: 'Remove' at: 0 anArg: 1.
	buttonMatrix setTitle: 'File Out...' at: 0 anArg: 2.
	buttonMatrix setTitle: 'Add' at: 0 anArg: 3.
	buttonMatrix setTitle: 'Compile' at: 0 anArg: 4.
	buttonMatrix setTitle: 'Remove' at: 0 anArg: 5.
	"	
	buttonMatrix setTitle: 'Compile' at: 0 anArg: 0.
	buttonMatrix setTitle: 'Add' at: 0 anArg: 1.
	buttonMatrix setTitle: 'Remove' at: 0 anArg: 2.
	buttonMatrix setTitle: 'Add Cata...' at: 0 anArg: 3.
	buttonMatrix setTitle: 'File Out Cat...' at: 0 anArg: 4.
	buttonMatrix setTitle: 'Remove Cata...' at: 0 anArg: 5.
	"!

initButtons: rect
	^self
!

initSplitView: rect
	| bounds contentView size |
	bounds _ Rect alloc initFromRect: (rect asCPointer).	
	bounds setX: 0.0 ; setY: 0.0; setHeight: ((rect height) - 30.0).
	box _ Box alloc initFrame: (bounds asCPointer).
	box notifyAncestorWhenFrameChanged: YES.
	box setAutoresizeSubviews: YES.
	box setAutosizing: (2 bitOr:8; bitOr: 16).
	box setTitlePosition: 0.						" 0 = No Title "
	box setBorderType: 0.							" 0 = No Border "
	splitView _ NXSplitView alloc initFrame: (bounds asCPointer).
	box setContentView: (splitView id).
!

initBrowser: rect
	browser _ NXBrowser alloc initFrame: (rect asCPointer).
	methodBrowserDelegate _ MethodBrowserDelegate alloc init.
	methodBrowserDelegate browseClass: class.
	browser setDelegate: (methodBrowserDelegate id).
	browser setTarget: (self id).
	browser setAction: (OCInterface getUid: 'action1:').
	browser setEmptySelectionEnabled: NO.
	browser setHorizontalScrollButtonsEnabled: NO.
	browser setHorizontalScrollerEnabled: NO.
	browser setMaxVisibleColumns: 2.
	browser loadColumnZero.
!

init
	| rect |
	super init.
	rect _ Rect alloc initFromX: 200.0 y: 200.0 width: 500.0 height: 400.0.
	self initWindow: rect.
	self initBrowser: rect.
	self initScrolledText: rect.
	self initSplitView: rect.
	self initButtonMatrix: rect.
	self initBrowseTypeButtonMatrix: rect.
	self compose.
!

compose
	| contentView |
	" Arranges everything on screen so that it looks nice "
	
	contentView _ window contentView.
	contentView notifyAncestorWhenFrameChanged: YES.
	contentView setAutoresizeSubviews: YES.
	splitView addSubview: browser id.
	splitView addSubview: buttonMatrix id.
	splitView addSubview: scrolledText id.
	contentView addSubview: box id.
	contentView addSubview: browseTypeMatrix id.
	contentView display.
!

initWithClass: aClass
	" This is the designated initializer for this Object "
	class _ aClass.
	self init.
!!

