"
| ============================================================================
| Below is the MethodBrowserDelegate class code
| ============================================================================
"

STNormalBrowserDelegate subclass: #MethodBrowserDelegate
		 instanceVariableNames: 'isInstBrowsing curClass'
		 classVariableNames: ''
		 poolDictionaries: ''
		 category: nil
!

MethodBrowserDelegate comment: 'Delegate to a browser that display the categories
and methods for a specific class' !

!MethodBrowserDelegate methodsFor: 'Instance initialization'!

init
	"Inits instance vars"
	super init.
	isInstBrowsing _ true.
	curClass _ Object.
!!

!MethodBrowserDelegate methodsFor: 'Browsing'!

browseInstanceMethods
	" Sets isInstBrowsing to true "
	isInstBrowsing _ true.
!

browseClassMethods
	" Sets isInstBrowsing to false "
	isInstBrowsing _ false.
!

browseClass: aClass
	" Sets isInstBrowsing to true "
	curClass _ aClass.
!

	
browser: arg0 titleOfColumn: arg1 
	isInstBrowsing	
		ifTrue: [ ^'Instance Categories' ]
		ifFalse: [ ^'Class Categories' ]
!

browser: arg0 fillMatrix: arg1 inColumn: arg2
	| sender matrix column cell categories i catSelectors curCategory |
	matrix _ Matrix newWithId: arg1.
	sender _ NXBrowser newWithId: arg0.
	column _ arg2.

	(column == 0)
		ifTrue: [
			" Find out how many categories we have "

			isInstBrowsing
				ifTrue: [ categories _ curClass categories. ]
				ifFalse: [ categories _ curClass class categories. ].

			i _ 0.
			((categories size) == 0)
				ifTrue: [ ^0 ].						
			categories asSortedCollection
				do: [ :cat |
					matrix addRow.
					cell _ matrix cellAt: i anArg: 0.
					cell setStringValue: (cat asString).
					cell setLoaded: YES.
					cell setLeaf: NO.
					i _ i + 1 ]. 
				^i. ]
		ifFalse: [
			curCategory _ sender selectedCell stringValue.

			isInstBrowsing
				ifTrue: [ catSelectors _ curClass selectorsIn: curCategory. ]
				ifFalse: [ catSelectors _ curClass class selectorsIn: curCategory. ].

			i _ 0.
			catSelectors asSortedCollection
				 do: [ :sel |
					matrix addRow.
					cell _ matrix cellAt: i anArg: 0.
					cell setStringValue: (sel asString).
					cell setLoaded: YES.
					cell setLeaf: YES.
					i _ i + 1. ].
				^i ].
	^0
!

browser: arg0 getNumRowsInColumn: arg1
	^0
!!
