
#import <appkit/appkit.h>

@interface KeyEvent : Object
{
	NXEvent event;
}

- initFromEvent:(NXEvent *)e;

// Usefull is you want to use an event object over and over again within
// a single section of code without creating new ones.

- setEvent:(NXEvent *)e;

- (int)type;
- location:(NXPoint *)p;
- (long)time;
- (int)flags;
- (unsigned int)window;
- (DPSContext)dpsContext;

- (short)reserved; 
- (short)repeat; 
- (unsigned short)charSet; 
- (unsigned short)charCode; 
- (unsigned short)keyCode; 
- (short)keyData;

@end

@interface MouseEvent : Object
{
	NXEvent event;
}

- initFromEvent:(NXEvent *)e;

- setEvent:(NXEvent *)e;

- (int)type;
- location:(NXPoint *)p;
- (long)time;
- (int)flags;
- (unsigned int)window;
- (DPSContext)dpsContext;

- (short)reserved; 
- (short)eventNum; 
- (int)click; 
- (unsigned char)pressure; 
- (char)reserved1; 
- (short)reserved2;

@end

@interface TrackingEvent : Object
{
	NXEvent event;
}

- initFromEvent:(NXEvent *)e;

- setEvent:(NXEvent *)e;

- (int)type;
- location:(NXPoint *)p;
- (long)time;
- (int)flags;
- (unsigned int)window;
- (DPSContext)dpsContext;

- (short)reserved; 
- (short)eventNum; 
- (int)trackingNum; 
- (int)userData; 

@end