"======================================================================
|
|   Experimental Button built in STIX.
|
|   $Revision: 1.4 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     16 Feb 92	  created.
|
"

FileStream fileIn: 'Widget.st'!

Widget subclass: #Button
       instanceVariableNames: 'highlight drawProc isDown rect xorGC 
                               highlightState'
       classVariableNames: ''
       poolDictionaries: ''
       category: 'STIX hacking'
!

!Button class methodsFor: 'Instance creation'!

createOn: parent in: aRect notifying: anObject with: aValue drawWith: aBlock
    | inst server screen |
    server _ parent server.
    screen _ server root screens at: 1.
    inst _ self createWindow: parent class: #InputOutput
		depth: 0
		visual: #CopyFromParent 
		x: aRect left y: aRect top
		width: aRect width height: aRect height
		borderWidth: 1 onServer: server
		attrs: [ :r | r eventMask: #(Exposure ButtonPress 
						 ButtonRelease 
						 PointerMotionHint);
				  backgroundPixel: screen whitePixel].
    inst init: parent in: aRect notifying: anObject with: aValue 
	      drawWith: aBlock.
    ^inst
	
! !


!Button methodsFor: 'private'!

init: parent in: aRect notifying: anObject with: selector drawWith: aBlock
    rect _ 0@0 extent: (aRect width)@(aRect height).
    highlight _ false.
    notify _ anObject.
    notifyVal _ selector.
    drawProc _ aBlock.
    self setupHandlers.
    self mapWindow.
!

setupHandlers
    isDown _ false.
    self registerFor: ButtonPressEvent
      when: [ :e | e event == id ]
      do: [ :e | e detail == 3 ifTrue: [ ExitHandlerLoop _ true ].
		 e detail == 1 ifTrue: [ self highlight ].
		     ].
    self registerFor: ButtonReleaseEvent
	 when: [ :e | e event == id ]
	 do: [ :e | e detail == 3 ifTrue: [ ExitHandlerLoop _ true ].
		    e detail == 1 ifTrue: 
			[ self unhighlight.
			  (rect containsPoint: (e eventX @ e eventY ))
			      ifTrue: [ notify perform: notifyVal with: self ].
			  ].
		    ].
    self registerFor: NoExposureEvent
	when: [ :e | true ]
	do: [ :e | nil ].
    self registerFor: ExposeEvent
	when: [ :e | e window == id ]
	do: [ :e | drawProc value: self ].
    self registerFor: MotionNotifyEvent
	when: [ :e | "e inspect."
		     e event == id ]
	do: [ :e | (rect containsPoint: (e eventX @ e eventY ))
		       ifTrue: [ e state ~= 0 ifTrue: 
				     [ self highlight ] ]
		       ifFalse: [ e state ~= 0 ifTrue:
				      [ self unhighlight ] ]
		       ].
!

highlight
    self setHighlight: true.
!

unhighlight
    self setHighlight: false.
!

setHighlight: desiredValue
    desiredValue ~= highlightState
	ifTrue: [ self makeGC.
		  self polyFillRectangle: xorGC
		      rectangles: (Array with: rect).
		  highlightState _ desiredValue ].
!

makeGC
    | screen | 
    screen _ server root screens at: 1.
    xorGC isNil ifTrue:
	[ xorGC _ GC createGC: self onServer: server
	     args: [ :r | r function: #Xor;
			      foreground: (screen whitePixel 
					       bitOr: screen blackPixel) ].
"	     args: [ :r | r function: #Invert;
			      foreground: screen whitePixel;
			      background: screen blackPixel ]. "
	  ].
! !
