"======================================================================
|
|   A faster read/write stream for X.
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
|
"


ReadWriteStream subclass: #FastRWStream
		instanceVariableNames: ''
		classVariableNames: 'initialized'
		poolDictionaries: ''
		category: nil
!

FastRWStream comment:
'I implement very fast bulk write (nextPutAll:) operations on
(ByteArray based) character streams.'!


!FastRWStream class methodsFor: 'instance creation'!

"This should check that the base of the stream is a character type stream"

initialized
    initialized _ true.
! !


!FastRWStream methodsFor: 'accessing-writing'!

nextPutAll: aCollection
    | collEnd newCollection |
    "Should ensure that collection is a string or byte array"
    initialized isNil ifTrue: [ ^super nextPutAll: aCollection ].
    collEnd _ ptr + aCollection size - 1.
    (collEnd > maxSize) ifTrue: 
	[ newCollection _ ByteArray new: collEnd + 1.
	  newCollection replaceFrom: 1 to: collection size with: collection.
	  maxSize _ newCollection size.
	  collection become: newCollection ].
    "Should check for byte array or not"
    collection replaceFrom: ptr to: collEnd 
	       with: aCollection startingAt: 1.
    collEnd > endPtr ifTrue: [ endPtr _ collEnd ].
    ptr _ collEnd + 1.
    ^aCollection
! !


