"======================================================================
|
|   Expermental GUI widgets written in STIX
|
|   $Revision: 1.4 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     16 Feb 92	  created.
|
"

Button subclass: #LabelledButton
       instanceVariableNames: 'label width height fontInfo gc'
       classVariableNames: ''
       poolDictionaries: ''
       category: 'X widgets'
!

Smalltalk at: #RealFontInfo put: nil!

!LabelledButton class methodsFor: 'instance creation'!

createOn: parent at: aPoint notifying: anObject with: aValue font: aFont
    label: aString
    | inst fontInfo aRect width height |
    fontInfo _ RealFontInfo.
    width _ self measure: aString withFont: fontInfo.
    height _ fontInfo fontAscent + fontInfo fontDescent.
    aRect _ aPoint extent: (width @ height).
    inst _ self createOn: parent
		in: aRect 
		notifying: anObject with: aValue
		drawWith: [ :button | button draw ].
    inst init: aRect font: aFont fontInfo: fontInfo label: aString.
    ^inst
!

measure: aString withFont: fontInfo
    | charInfo totalWidth ch min charInfos |
    "Need to check minByte & maxByte properly"
    (fontInfo minByte1 ~= 0
	or: [ fontInfo maxByte1 ~= 0 ])
	ifTrue: [ ^self error: 'unhandled case: minByte or maxByte are nonzero' ].
    totalWidth _ 0.
    min _ fontInfo minCharOrByte2.
    charInfos _ fontInfo charInfos.
    aString do:
	[ :char | ch _ char asciiValue - min.
		  charInfo _ charInfos at: ch + 1.
		  totalWidth _ totalWidth + charInfo characterWidth ].
    ^totalWidth
! !


!LabelledButton methodsFor: 'accessing'!

width
    ^width
!

height
    ^height
!

width: aWidth
    self notYetImplemented
! !

!LabelledButton methodsFor: 'private'!

init: aRect font: aFont fontInfo: aFontInfo label: aString
    | screen |
    screen _ server root screens at: 1.
    fontInfo _ aFontInfo.
    label _ aString.
    width _ aRect width.
    height _ aRect width.
    gc _ GC createGC: self onServer: server
	     args: [ :r | r foreground: screen whitePixel;
			      background: screen blackPixel;
			      font: aFont ].
!

draw
    'drawing' printNl.
    self imageText8: gc x: 0 y: fontInfo fontAscent
	 string: label
! !

