"======================================================================
|
|   X configure window request.
|   Used for building up an XConfigureWindow request.
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     18 Nov 90	  Created.
|
"
XRequest subclass: #XConfigureWindowRequest
	 instanceVariableNames: ''
	 classVariableNames: ''
	 poolDictionaries: ''
	 category: 'X request container'!

XConfigureWindowRequest comment: '###No comment yet'!



!XConfigureWindowRequest class methodsFor: 'instance creation'!

command: aByte aux: aByte2
    ^self new init: aByte aux: aByte2
! !



!XConfigureWindowRequest methodsFor: 'X variable flags'!

queueOn: aServer
    | length |
    "### Re-factor this and parent queueOn: method"
    self pad.
    self emitBitValues: true.
    length _ stream position // 4.
    stream position: 3.
    self word: length.
    ^aServer queueRequest: stream contents
! !



!XConfigureWindowRequest methodsFor: 'variable arity requests'!

x: aValue
    self at: 1 word: aValue
!

y: aValue
    self at: 2 word: aValue
!

width: aValue
    self at: 3 uword: aValue
!

height: aValue
    self at: 4 uword: aValue
!

borderWidth: aValue
    self at: 5 uword: aValue
!

sibling: aValue
    self at: 6 ulong: aValue id
!

stackMode: aValue
    self at: 7 ubyte: (XProtocol map: aValue 
				into: #(Above Below TopIf BottomIf Opposite))
! !

!XConfigureWindowRequest methodsFor: 'local initialization'!

localInit
    values _ Array new: 32	"large enough"
! !



LoadStatus _ 'XConfigureWindowRequest'!
