"======================================================================
|
|   Definitions of replies to X protocol operations
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     16 Feb 92	  Created a while ago (like fall 90).
|
"
XProtocol subclass: #XProtoResponses "maybe events live under here too?"
	  instanceVariableNames: ''
	  classVariableNames: ''
	  poolDictionaries: ''
	  category: 'X Protocol Responses'
!

"Should this be broken down into separate files or kept in one gigantic
file?"


!XProtoResponses class methodsFor: 'subclass creation'!

defineReply: responseName instanceVariableNames: names
    | respClass namesList |
    
    stdout nextPutAll: 'Defining ', responseName; nl.
    respClass _ self subclass: responseName
		     instanceVariableNames: names
		     classVariableNames: ''
		     poolDictionaries: ''
		     category: 'X Protocol Responses'.
    namesList _ (TokenStream on: names) contents.
    XProtocol defineAccessors: namesList forClass: respClass.
    XProtocol defineInstCreation: namesList forClass: respClass
! !



XProtoResponses defineReply: #InitializeReply
		instanceVariableNames: 
		    'majorVersion minorVersion releaseNum resourceIdBase 
    	    	     resourceIdMask motionBufferSize maxRequestLen 
    	    	     imageByteOrder bitmapBitOrder bitmapFormatScanUnit 
    	    	     bitmapFormatScanPad minKeycode maxKeycode vendor
    	    	     formats screens'
!

XProtoResponses defineReply: #AllocColorReply
		instanceVariableNames:
		    'red green blue pixel'
!

XProtoResponses defineReply: #AllocColorCellsReply
		instanceVariableNames:
		    'pixels masks'
!

XProtoResponses defineReply: #AllocColorPlanesReply
		instanceVariableNames:
		    'redMask greenMask blueMask pixels'
!

XProtoResponses defineReply: #AllocNamedColorReply
		instanceVariableNames:
		    'pixel exactRed exactGreen exactBlue visualRed visualGreen
    	    	     visualBlue'
!

XProtoResponses defineReply: #GetAtomNameReply
		instanceVariableNames:
		    'name'
!

XProtoResponses defineReply: #GetFontPathReply
		instanceVariableNames:
		    'path'
!

XProtoResponses defineReply: #GetGeometryReply
		instanceVariableNames: 
		    'depth root x y width height borderWidth'
!

XProtoResponses defineReply: #GetImageReply
		instanceVariableNames:
		    'depth visual data'
!
    

XProtoResponses defineReply: #GetInputFocusReply
		instanceVariableNames:
		    'revertTo focus'
!

XProtoResponses defineReply: #GetKeyboardControlReply
		instanceVariableNames:
		    'globalAutoRepeat ledMask keyClickPercent bellPercent
    	    	     bellPitch bellDuration autoRepeats'
!

XProtoResponses defineReply: #GetKeyboardMappingReply
		instanceVariableNames:
		    'keysymsPerKeycode keysyms'
!

XProtoResponses defineReply: #GetModifierMappingReply
		instanceVariableNames:
		    'keycodesPerModifier keycodes'
!

XProtoResponses defineReply: #GetMotionEvents
		instanceVariableNames:
		    'events'
!

XProtoResponses defineReply: #GetPointerControlReply
		instanceVariableNames:
		    'accelerationNumerator accelerationDenominator
    	    	     threshold'
!

XProtoResponses defineReply: #GetPointerMappingReply
		instanceVariableNames:
		    'map'
!

XProtoResponses defineReply: #GetPropertyReply
		instanceVariableNames: 
		    'format type bytesAfter value'
!

XProtoResponses defineReply: #GetScreenSaverReply
		instanceVariableNames:
		    'timeout interval preferBlanking allowExposures'
!

XProtoResponses defineReply: #GetSelectionOwnerReply
		instanceVariableNames:
		    'owner'
!

XProtoResponses defineReply: #GetWindowAttributesReply
		instanceVariableNames: 
		    'backingStore visual winClass bitGravity winGravity 
    	    	     backingPlanes backingPixel saveUnder mapIsInstalled
    	    	     mapState overrideRedirect colormap allEventMasks
    	    	     yourEventMask doNotPropagateMask'
!

XProtoResponses defineReply: #GrabKeyboardReply
		instanceVariableNames:
		    'status'
!

XProtoResponses defineReply: #GrabPointerReply
		instanceVariableNames:
		    'status'
!

XProtoResponses defineReply: #InternAtomReply
		instanceVariableNames: 
		    'atom'
!

XProtoResponses defineReply: #ListExtensionsReply
		instanceVariableNames:
		    'names'
!

XProtoResponses defineReply: #ListFontsReply
		instanceVariableNames: 
		    'names'
!

XProtoResponses defineReply: #ListFontsWithInfoReply
		instanceVariableNames:
		    'minBounds maxBounds minCharOrByte2 maxCharOrByte2 
    	    	     defaultChar drawDirection minByte1 maxByte1 allCharsExist
    	    	     fontAscent fontDescent properties name'
!

XProtoResponses defineReply: #ListHostsReply
		instanceVariableNames:
		    'hosts'
!

XProtoResponses defineReply: #ListInstalledColormapsReply
		instanceVariableNames:
		    'cmaps'
!

XProtoResponses defineReply: #ListPropertiesReply
		instanceVariableNames:
		    'atoms'
!

XProtoResponses defineReply: #LookupColorReply
		instanceVariableNames:
		    'exactRed exactGreen exactBlue visualRed visualGreen
    	    	     visualBlue'
!

XProtoResponses defineReply: #QueryBestSizeReply
		instanceVariableNames:
		    'width height'
!

XProtoResponses defineReply: #QueryColorsReply
		instanceVariableNames:
		    'colors'
!

XProtoResponses defineReply: #QueryExtensionReply
		instanceVariableNames:
		    'present majorOpcode firstEvent firstError'
!

XProtoResponses defineReply:#QueryFontReply
		instanceVariableNames:
		    'minBounds maxBounds minCharOrByte2 maxCharOrByte2 
	    	     defaultChar drawDirection minByte1 maxByte1 allCharsExist
    	    	     fontAscent fontDescent properties charInfos'
!

XProtoResponses defineReply: #QueryKeymapReply
		instanceVariableNames:
		    'keys'
!

XProtoResponses defineReply: #QueryPointerReply
		instanceVariableNames:
		    'sameScreen root child rootX rootY winX winY mask'
!

XProtoResponses defineReply: #QueryTextExtentsReply
		instanceVariableNames: 
		    'drawDirection fontAscent fontDescent overallAscent
    	    	     overallDescent overallWidth overallLeft overallRight'
!


XProtoResponses defineReply: #QueryTreeReply
		instanceVariableNames: 
		    'root parent children'
!

XProtoResponses defineReply: #SetModifierMappingReply
		instanceVariableNames:
		    'status'
!

XProtoResponses defineReply: #SetPointerMappingReply
		instanceVariableNames:
		    'status'
!

XProtoResponses defineReply: #TranslateCoordinatesReply
		instanceVariableNames: 
		    'sameScreen child dstX dstY'
!

LoadStatus _ 'XProtoResponses'!
