"======================================================================
|
|   Base class for all the STIX X objects
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     26 Oct 90	  Created.
|
"



XProtocol subclass: #XServerObject
	  instanceVariableNames: 'server id'
	  classVariableNames: ''
	  poolDictionaries: ''
	  category: 'X Objects'
!

!XServerObject class methodsFor: 'quick instance creation'!

idFrom: aServer
    ^self new init: aServer ulong onServer: aServer
!

maybeIdFrom: aServer symbols: symbolArray
    | id |
    id _ aServer ulong.
    id < symbolArray size
	ifTrue: [ ^symbolArray at: id + 1 ]
	ifFalse: [ ^self new init: id onServer: aServer ]
! !



!XServerObject methodsFor: 'accessing'!

id
    ^id
!

server
    ^server
! !


!XServerObject methodsFor: 'X protocol implementation'!

justId: reqNum
    | req |
    req _ XRequest fixedCommand: reqNum.
    req ulong: id.
    req queueOn: server
! !



!XServerObject methodsFor: 'private'!

init: idVar onServer: serverVar
    id _ idVar.
    server _ serverVar.
    server registerId: id as: self
! !

LoadStatus _ 'XServerObject'!

FileStream fileIn: 'Server.st'!
FileStream fileIn: 'Drawable.st'!
FileStream fileIn: 'Colormap.st'!
FileStream fileIn: 'Cursor.st'!
FileStream fileIn: 'Fontable.st'!
FileStream fileIn: 'Atom.st'!
FileStream fileIn: 'Visual.st'!

