"======================================================================
|
|   XWindowRequest definitions.
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

 "======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     18 Nov 90	  Created.
|
"
XRequest subclass: #XWindowRequest
	 instanceVariableNames: ''
	 classVariableNames: ''
	 poolDictionaries: ''
	 category: 'X request container'!

XWindowRequest comment: '###No comment yet'!



!XWindowRequest class methodsFor: 'instance creation'!

command: aByte aux: aByte2
    ^self new init: aByte aux: aByte2
! !



!XWindowRequest methodsFor: 'X variable flags'!

queueOn: aServer
    | length |
    "### Re-factor this and parent queueOn: method"
    self pad.
    self emitBitValues: false.
    length _ stream position // 4.
    stream position: 3.
    self word: length.
    ^aServer queueRequest: stream contents
! !



!XWindowRequest methodsFor: 'variable arity requests'!

backgroundPixmap: aValue
    self at: 1 ulong: (XProtocol maybeMapId: aValue 
				 into: #(None ParentRelative))
!

backgroundPixel: aValue
    self at: 2 ulong: aValue
!

borderPixmap: aValue
    self at: 3 ulong: (XProtocol maybeMapId: aValue into: #(CopyFromParent))
!

borderPixel: aValue
    self at: 4 ulong: aValue
!

bitGravity: aValue
    self at: 5 ubyte: (XProtocol map: aValue into: BitGravityNames)
!

winGravity: aValue
    self at: 6 ubyte: (XProtocol map: aValue into: WinGravityNames) 
!

backingStore: aValue
    self at: 7 ubyte: (XProtocol map: aValue into: #(NotUseful WhenMapped Always))
!

backingPlanes: aValue
    self at: 8 ulong: aValue
!

backingPixel: aValue
    self at: 9 ulong: aValue
!

overrideRedirect: aValue
    self at: 10 bool: aValue
!

saveUnder: aValue
    self at: 11 bool: aValue
!

eventMask: aValue
    self at: 12 ulong: (XProtocol mask: aValue using: EventNames)
!    

doNotPropagateMask: aValue
    self at: 13 ulong: (XProtocol mask: aValue using: DeviceEventNames)
!

colormap: aValue
    self at: 14 ulong: (XProtocol maybeMapId: aValue into: #(CopyFromParent))
!

cursor: aValue
    self at: 15 ulong: (XProtocol maybeMapId: aValue into: #(None))
! !

!XWindowRequest methodsFor: 'local initialization'!

localInit
    values _ Array new: 32	"large enough"
! !


LoadStatus _ 'XWindowRequest'!
