"======================================================================
|
|   A simple paint program
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     30 Aug 94	  added header stuff.
|
"
 

Object subclass: #PaintIt
       instanceVariableNames: 'objects gc lastPt'
       classVariableNames: 'window'
       poolDictionaries: ''
       category: nil
!

FileStream fileIn: 'WinEvents.st'!
FileStream fileIn: 'paintsub.st'!
FileStream fileIn: 'paintline.st'!


!PaintIt class methodsFor: 'instance creation'!

new
    ^super new init
! !



!PaintIt methodsFor: 'operation'!

run
    window server processEvents.
!

stopRunning
    window server close.
    ExitHandlerLoop _ true.
! !


!PaintIt methodsFor: 'event handling'!

handleButtonPress: event
    | point |
    point _ event eventX @ event eventY.
    objects do: 
	[ :obj | (obj containsPoint: point) 
		     ifTrue: [ "###more"
			       ^self ] ].
    lastPt _ point.
!

handleButtonRelease: event
    | point |
    point _ event eventX @ event eventY.
    nil polyLine: gc coordinateMode: #Origin
	   points: (Array with: lastPt with: point).
!

handleButtonMotion: event
    | point | 
    point _ event eventX @ event eventY.
    window polyLine: gc coordinateMode: #Origin
	   points: (Array with: lastPt with: point).
    lastPt _ point.
!

handleKeyPress: event
    (event state == 5 "c-s-")
	ifTrue: [   "control = 83, shift = 106"
		     self stopRunning ].
! !





!PaintIt methodsFor: 'private'!

init
    | s root screen rootWin cmap |
    window notNil
	ifTrue: [ window server close.
		  " ### Very clumsy "
		  EventHandlers _ Dictionary new. ].
    s _ Server connectToDisplay.
    root _ s root.
    screen _ root screens at: 1.
    rootWin _ screen window.

    window _ Window createWindow: rootWin class: #CopyFromParent
		    depth: 0
		    visual: #CopyFromParent x: 0 y: 0
		    width: 400 height: screen heightInPixels
		   " width: screen widthInPixels height: screen heightInPixels"
		    borderWidth: 5 onServer: s
		    attrs: [ :r | r eventMask: #(Exposure 
						     ButtonPress ButtonRelease
						     Button1Motion
						     Button2Motion
						     Button3Motion
						     KeyPress );
				      backgroundPixel: screen whitePixel;
				      backingStore: #Always ].
    cmap _ screen defaultColormap.
    window name: 'Paint It!'.

"    redPix _ (cmap allocNamedColor: 'red') pixel.
    bluePix _ (cmap allocNamedColor: 'blue') pixel.
    greenPix _ (cmap allocNamedColor: 'green') pixel.
"
    objects _ OrderedCollection new: 0.
    gc _ GC createGC: window onServer: s 
	    args: [ :r | r foreground: screen blackPixel;
			     capStyle: #Round].

    self registerEventHandlers.    
    window mapWindow.

    ColorChooser on: window gc: gc.
    StyleChooser on: window gc: gc.
!

registerEventHandlers
    window registerFor: ExposeEvent
	   when: [ :e | e window == window id ]
	   do: [ :e | e count = 0 ].
    window registerFor: ButtonPressEvent
	   when: [ :e | e event == window id ]
	   do: [ :e | self handleButtonPress: e ].
    
    window registerFor: ButtonReleaseEvent
	   when: [ :e | e event == window id ]
	   do: [ :e | self handleButtonRelease: e ].
    
    window registerFor: KeyPressEvent
	   when: [ :e | e event == window id ]
	   do: [ :e | self handleKeyPress: e ].
    
    window registerFor: MotionNotifyEvent
	   when: [ :e | e event == window id ]
	   do: [ :e | self handleButtonMotion: e ].

    " ### more "
! !



| pi |
    pi _ PaintIt new.
    pi run
!

