"======================================================================
|
|   Test out creating a pixmap and using it using STIX.
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     30 Aug 94	  added header stuff.
|
"
 
Smalltalk at: #ServerConn put: nil!

| root screen rootWin w s gc bits str pix pgc |
    ServerConn notNil ifTrue: [ServerConn close].
    ServerConn _ s _ Server connectToDisplay.
    root _ s root.
    screen _ root screens at: 1.
    rootWin _ screen window.

    bits _ #(
    	2r0101010101010101
    	2r1010101010101010
    	2r0101010101010101
    	2r1010101010101010
    	2r0101010101010101
    	2r1010101010101010
    	2r0101010101010101
    	2r1010101010101010
    	2r0101010101010101
    	2r1010101010101010
    	2r0101010101010101
    	2r1010101010101010
    	2r0101010101010101
    	2r1010101010101010
    	2r0101010101010101
    	2r1010101010101010
    ).
    str _ WriteStream on: #(ByteArray new: 32).
    bits do: [ :word | str nextPut: 0; nextPut: 0.
		       str nextPut: word // 256. 
		       str nextPut: (word bitAnd: 255). ].
    str contents printNl.
    bits _ str contents.

    pix _ Pixmap createPixmap: rootWin depth: 8 width: 16 height: 16.

    pgc _ GC createGC: pix onServer: s args: nil.


    pix putImage: pgc depth: 1 width: 16 height: 16 dstX: 0 dstY: 0
	leftPad: 16 format: #Bitmap data: bits.



    w _ Window createWindow: rootWin class: #InputOutput
	       depth: 0
	       visual: #CopyFromParent x: 0 y: 0
	       width: 300 height: 200 borderWidth: 5 onServer: s
	       attrs: [ :r | r eventMask: #(Exposure ButtonPress);
				 "backgroundPixel: screen whitePixel;"
				 backgroundPixmap: pix ].
    w mapWindow.
    s nextEvent.

    gc _ GC createGC: w onServer: s args: 
	[ :r | r joinStyle: #Round;
		   capStyle: #Round;
		   foreground: screen blackPixel ].

    w polyRectangle: gc rectangles: (Array with: (16@16 extent: 50@50)).

!
